ace.define("ace/snippets",["require","exports","module","ace/lib/dom","ace/lib/oop","ace/lib/event_emitter","ace/lib/lang","ace/range","ace/range_list","ace/keyboard/hash_handler","ace/tokenizer","ace/clipboard","ace/editor"],function(b,L,U){"use strict";var _=b("./lib/dom"),M=b("./lib/oop"),E=b("./lib/event_emitter").EventEmitter,C=b("./lib/lang"),y=b("./range").Range,x=b("./range_list").RangeList,S=b("./keyboard/hash_handler").HashHandler,O=b("./tokenizer").Tokenizer,k=b("./clipboard"),P={CURRENT_WORD:function(o){return o.session.getTextRange(o.session.getWordRange())},SELECTION:function(o,i,e){var s=o.session.getTextRange();return e?s.replace(/\n\r?([ \t]*\S)/g,"\n"+e+"$1"):s},CURRENT_LINE:function(o){return o.session.getLine(o.getCursorPosition().row)},PREV_LINE:function(o){return o.session.getLine(o.getCursorPosition().row-1)},LINE_INDEX:function(o){return o.getCursorPosition().row},LINE_NUMBER:function(o){return o.getCursorPosition().row+1},SOFT_TABS:function(o){return o.session.getUseSoftTabs()?"YES":"NO"},TAB_SIZE:function(o){return o.session.getTabSize()},CLIPBOARD:function(o){return k.getText&&k.getText()},FILENAME:function(o){return/[^/\\]*$/.exec(this.FILEPATH(o))[0]},FILENAME_BASE:function(o){return/[^/\\]*$/.exec(this.FILEPATH(o))[0].replace(/\.[^.]*$/,"")},DIRECTORY:function(o){return this.FILEPATH(o).replace(/[^/\\]*$/,"")},FILEPATH:function(o){return"/not implemented.txt"},WORKSPACE_NAME:function(){return"Unknown"},FULLNAME:function(){return"Unknown"},BLOCK_COMMENT_START:function(o){var i=o.session.$mode||{};return i.blockComment&&i.blockComment.start||""},BLOCK_COMMENT_END:function(o){var i=o.session.$mode||{};return i.blockComment&&i.blockComment.end||""},LINE_COMMENT:function(o){return(o.session.$mode||{}).lineCommentStart||""},CURRENT_YEAR:T.bind(null,{year:"numeric"}),CURRENT_YEAR_SHORT:T.bind(null,{year:"2-digit"}),CURRENT_MONTH:T.bind(null,{month:"numeric"}),CURRENT_MONTH_NAME:T.bind(null,{month:"long"}),CURRENT_MONTH_NAME_SHORT:T.bind(null,{month:"short"}),CURRENT_DATE:T.bind(null,{day:"2-digit"}),CURRENT_DAY_NAME:T.bind(null,{weekday:"long"}),CURRENT_DAY_NAME_SHORT:T.bind(null,{weekday:"short"}),CURRENT_HOUR:T.bind(null,{hour:"2-digit",hour12:!1}),CURRENT_MINUTE:T.bind(null,{minute:"2-digit"}),CURRENT_SECOND:T.bind(null,{second:"2-digit"})};function T(o){var i=(new Date).toLocaleString("en-us",o);return 1==i.length?"0"+i:i}P.SELECTED_TEXT=P.SELECTION;var A=function(){function o(){this.snippetMap={},this.snippetNameMap={},this.variables=P}return o.prototype.getTokenizer=function(){return o.$tokenizer||this.createTokenizer()},o.prototype.createTokenizer=function(){function i(t){return t=t.substr(1),/^\d+$/.test(t)?[{tabstopId:parseInt(t,10)}]:[{text:t}]}function e(t){return"(?:[^\\\\"+t+"]|\\\\.)"}var s={regex:"/("+e("/")+"+)/",onMatch:function(t,r,l){var a=l[0];return a.fmtString=!0,a.guard=t.slice(1,-1),a.flag="",""},next:"formatString"};return o.$tokenizer=new O({start:[{regex:/\\./,onMatch:function(t,r,l){var a=t[1];return("}"==a&&l.length||-1!="`$\\".indexOf(a))&&(t=a),[t]}},{regex:/}/,onMatch:function(t,r,l){return[l.length?l.shift():t]}},{regex:/\$(?:\d+|\w+)/,onMatch:i},{regex:/\$\{[\dA-Z_a-z]+/,onMatch:function(t,r,l){var a=i(t.substr(1));return l.unshift(a[0]),a},next:"snippetVar"},{regex:/\n/,token:"newline",merge:!1}],snippetVar:[{regex:"\\|"+e("\\|")+"*\\|",onMatch:function(t,r,l){var a=t.slice(1,-1).replace(/\\[,|\\]|,/g,function(f){return 2==f.length?f[1]:"\0"}).split("\0").map(function(f){return{value:f}});return l[0].choices=a,[a[0]]},next:"start"},s,{regex:"([^:}\\\\]|\\\\.)*:?",token:"",next:"start"}],formatString:[{regex:/:/,onMatch:function(t,r,l){return l.length&&l[0].expectElse?(l[0].expectElse=!1,l[0].ifEnd={elseEnd:l[0]},[l[0].ifEnd]):":"}},{regex:/\\./,onMatch:function(t,r,l){var a=t[1];return"}"==a&&l.length||-1!="`$\\".indexOf(a)?t=a:"n"==a?t="\n":"t"==a?t="\t":-1!="ulULE".indexOf(a)&&(t={changeCase:a,local:a>"a"}),[t]}},{regex:"/\\w*}",onMatch:function(t,r,l){var a=l.shift();return a&&(a.flag=t.slice(1,-1)),this.next=a&&a.tabstopId?"start":"",[a||t]},next:"start"},{regex:/\$(?:\d+|\w+)/,onMatch:function(t,r,l){return[{text:t.slice(1)}]}},{regex:/\${\w+/,onMatch:function(t,r,l){var a={text:t.slice(2)};return l.unshift(a),[a]},next:"formatStringVar"},{regex:/\n/,token:"newline",merge:!1},{regex:/}/,onMatch:function(t,r,l){var a=l.shift();return this.next=a&&a.tabstopId?"start":"",[a||t]},next:"start"}],formatStringVar:[{regex:/:\/\w+}/,onMatch:function(t,r,l){return l[0].formatFunction=t.slice(2,-1),[l.shift()]},next:"formatString"},s,{regex:/:[\?\-+]?/,onMatch:function(t,r,l){"+"==t[1]&&(l[0].ifEnd=l[0]),"?"==t[1]&&(l[0].expectElse=!0)},next:"formatString"},{regex:"([^:}\\\\]|\\\\.)*:?",token:"",next:"formatString"}]})},o.prototype.tokenizeTmSnippet=function(i,e){return this.getTokenizer().getLineTokens(i,e).tokens.map(function(s){return s.value||s})},o.prototype.getVariableValue=function(i,e,s){if(/^\d+$/.test(e))return(this.variables.__||{})[e]||"";if(/^[A-Z]\d+$/.test(e))return(this.variables[e[0]+"__"]||{})[e.substr(1)]||"";if(e=e.replace(/^TM_/,""),!this.variables.hasOwnProperty(e))return"";var t=this.variables[e];return"function"==typeof t&&(t=this.variables[e](i,e,s)),null==t?"":t},o.prototype.tmStrFormat=function(i,e,s){if(!e.fmt)return i;var r=e.guard;r=new RegExp(r,(e.flag||"").replace(/[^gim]/g,""));var l="string"==typeof e.fmt?this.tokenizeTmSnippet(e.fmt,"formatString"):e.fmt,a=this,f=i.replace(r,function(){var u=a.variables.__;a.variables.__=[].slice.call(arguments);for(var m=a.resolveVariables(l,s),d="E",v=0;v<m.length;v++){var g=m[v];if("object"==typeof g)if(m[v]="",g.changeCase&&g.local){var w=m[v+1];w&&"string"==typeof w&&(m[v]="u"==g.changeCase?w[0].toUpperCase():w[0].toLowerCase(),m[v+1]=w.substr(1))}else g.changeCase&&(d=g.changeCase);else"U"==d?m[v]=g.toUpperCase():"L"==d&&(m[v]=g.toLowerCase())}return a.variables.__=u,m.join("")});return f},o.prototype.tmFormatFunction=function(i,e,s){return"upcase"==e.formatFunction?i.toUpperCase():"downcase"==e.formatFunction?i.toLowerCase():i},o.prototype.resolveVariables=function(i,e){for(var s=[],t="",r=!0,l=0;l<i.length;l++){var a=i[l];if("string"!=typeof a){if(a){if(r=!1,a.fmtString){var f=i.indexOf(a,l+1);-1==f&&(f=i.length),a.fmt=i.slice(l+1,f),l=f}if(a.text){var u=this.getVariableValue(e,a.text,t)+"";a.fmtString&&(u=this.tmStrFormat(u,a,e)),a.formatFunction&&(u=this.tmFormatFunction(u,a,e)),u&&!a.ifEnd?(s.push(u),m(a)):!u&&a.ifEnd&&m(a.ifEnd)}else a.elseEnd?m(a.elseEnd):(null!=a.tabstopId||null!=a.changeCase)&&s.push(a)}}else s.push(a),"\n"==a?(r=!0,t=""):r&&(t=/^\t*/.exec(a)[0],r=/\S/.test(a))}function m(d){var v=i.indexOf(d,l+1);-1!=v&&(l=v)}return s},o.prototype.getDisplayTextForSnippet=function(i,e){return $.call(this,i,e).text},o.prototype.insertSnippetForSelection=function(i,e,s){void 0===s&&(s={});var t=$.call(this,i,e,s),r=i.getSelectionRange();s.range&&0===s.range.compareRange(r)&&(r=s.range);var l=i.session.replace(r,t.text);new n(i).addTabstops(t.tabstops,r.start,l,i.inVirtualSelectionMode&&i.selection.index)},o.prototype.insertSnippet=function(i,e,s){void 0===s&&(s={});var t=this;if(s.range&&!(s.range instanceof y)&&(s.range=y.fromPoints(s.range.start,s.range.end)),i.inVirtualSelectionMode)return t.insertSnippetForSelection(i,e,s);i.forEachSelection(function(){t.insertSnippetForSelection(i,e,s)},null,{keepOrder:!0}),i.tabstopManager&&i.tabstopManager.tabNext()},o.prototype.$getScope=function(i){var e=i.session.$mode.$id||"";if("html"===(e=e.split("/").pop())||"php"===e){"php"===e&&!i.session.$mode.inlinePhp&&(e="html");var s=i.getCursorPosition(),t=i.session.getState(s.row);"object"==typeof t&&(t=t[0]),t.substring&&("js-"==t.substring(0,3)?e="javascript":"css-"==t.substring(0,4)?e="css":"php-"==t.substring(0,4)&&(e="php"))}return e},o.prototype.getActiveScopes=function(i){var e=this.$getScope(i),s=[e],t=this.snippetMap;return t[e]&&t[e].includeScopes&&s.push.apply(s,t[e].includeScopes),s.push("_"),s},o.prototype.expandWithTab=function(i,e){var s=this,t=i.forEachSelection(function(){return s.expandSnippetForSelection(i,e)},null,{keepOrder:!0});return t&&i.tabstopManager&&i.tabstopManager.tabNext(),t},o.prototype.expandSnippetForSelection=function(i,e){var f,s=i.getCursorPosition(),t=i.session.getLine(s.row),r=t.substring(0,s.column),l=t.substr(s.column),a=this.snippetMap;return this.getActiveScopes(i).some(function(u){var m=a[u];return m&&(f=this.findMatchingSnippet(m,r,l)),!!f},this),!!f&&(e&&e.dryRun||(i.session.doc.removeInLine(s.row,s.column-f.replaceBefore.length,s.column+f.replaceAfter.length),this.variables.M__=f.matchBefore,this.variables.T__=f.matchAfter,this.insertSnippetForSelection(i,f.content),this.variables.M__=this.variables.T__=null),!0)},o.prototype.findMatchingSnippet=function(i,e,s){for(var t=i.length;t--;){var r=i[t];if((!r.startRe||r.startRe.test(e))&&(!r.endRe||r.endRe.test(s))&&(r.startRe||r.endRe))return r.matchBefore=r.startRe?r.startRe.exec(e):[""],r.matchAfter=r.endRe?r.endRe.exec(s):[""],r.replaceBefore=r.triggerRe?r.triggerRe.exec(e)[0]:"",r.replaceAfter=r.endTriggerRe?r.endTriggerRe.exec(s)[0]:"",r}},o.prototype.register=function(i,e){var s=this.snippetMap,t=this.snippetNameMap,r=this;function l(u){return u&&!/^\^?\(.*\)\$?$|^\\b$/.test(u)&&(u="(?:"+u+")"),u||""}function a(u,m,d){return u=l(u),m=l(m),d?(u=m+u)&&"$"!=u[u.length-1]&&(u+="$"):(u+=m)&&"^"!=u[0]&&(u="^"+u),new RegExp(u)}function f(u){u.scope||(u.scope=e||"_"),s[e=u.scope]||(s[e]=[],t[e]={});var m=t[e];if(u.name){var d=m[u.name];d&&r.unregister(d),m[u.name]=u}s[e].push(u),u.prefix&&(u.tabTrigger=u.prefix),!u.content&&u.body&&(u.content=Array.isArray(u.body)?u.body.join("\n"):u.body),u.tabTrigger&&!u.trigger&&(!u.guard&&/^\w/.test(u.tabTrigger)&&(u.guard="\\b"),u.trigger=C.escapeRegExp(u.tabTrigger)),(u.trigger||u.guard||u.endTrigger||u.endGuard)&&(u.startRe=a(u.trigger,u.guard,!0),u.triggerRe=new RegExp(u.trigger),u.endRe=a(u.endTrigger,u.endGuard,!0),u.endTriggerRe=new RegExp(u.endTrigger))}i||(i=[]),Array.isArray(i)?i.forEach(f):Object.keys(i).forEach(function(u){f(i[u])}),this._signal("registerSnippets",{scope:e})},o.prototype.unregister=function(i,e){var s=this.snippetMap,t=this.snippetNameMap;function r(l){var a=t[l.scope||e];if(a&&a[l.name]){delete a[l.name];var f=s[l.scope||e],u=f&&f.indexOf(l);u>=0&&f.splice(u,1)}}i.content?r(i):Array.isArray(i)&&i.forEach(r)},o.prototype.parseSnippetFile=function(i){i=i.replace(/\r/g,"");for(var r,e=[],s={},t=/^#.*|^({[\s\S]*})\s*$|^(\S+) (.*)$|^((?:\n*\t.*)+)/gm;r=t.exec(i);){if(r[1])try{s=JSON.parse(r[1]),e.push(s)}catch(u){}if(r[4])s.content=r[4].replace(/^\t/gm,""),e.push(s),s={};else{var l=r[2],a=r[3];if("regex"==l){var f=/\/((?:[^\/\\]|\\.)*)|$/g;s.guard=f.exec(a)[1],s.trigger=f.exec(a)[1],s.endTrigger=f.exec(a)[1],s.endGuard=f.exec(a)[1]}else"snippet"==l?(s.tabTrigger=a.match(/^\S*/)[0],s.name||(s.name=a)):l&&(s[l]=a)}}return e},o.prototype.getSnippetByName=function(i,e){var t,s=this.snippetNameMap;return this.getActiveScopes(e).some(function(r){var l=s[r];return l&&(t=l[i]),!!t},this),t},o}();M.implement(A.prototype,E);var $=function(o,i,e){void 0===e&&(e={});var s=o.getCursorPosition(),t=o.session.getLine(s.row),r=o.session.getTabString(),l=t.match(/^\s*/)[0];s.column<l.length&&(l=l.slice(0,s.column)),i=i.replace(/\r/g,"");var a=this.tokenizeTmSnippet(i);a=(a=this.resolveVariables(a,o)).map(function(R){return"\n"!=R||e.excludeExtraIndent?"string"==typeof R?R.replace(/\t/g,r):R:R+l});var f=[];a.forEach(function(R,F){if("object"==typeof R){var z=R.tabstopId,N=f[z];if(N||((N=f[z]=[]).index=z,N.value="",N.parents={}),-1===N.indexOf(R)){R.choices&&!N.choices&&(N.choices=R.choices),N.push(R);var B=a.indexOf(R,F+1);if(-1!==B){var W=a.slice(F+1,B);W.some(function(j){return"object"==typeof j})&&!N.value?N.value=W:W.length&&(!N.value||"string"!=typeof N.value)&&(N.value=W.join(""))}}}}),f.forEach(function(R){R.length=0});var u={};function m(R){for(var F=[],z=0;z<R.length;z++){var N=R[z];if("object"==typeof N){if(u[N.tabstopId])continue;N=F[R.lastIndexOf(N,z-1)]||{tabstopId:N.tabstopId}}F[z]=N}return F}for(var d=0;d<a.length;d++){var v=a[d];if("object"==typeof v){var g=v.tabstopId,w=f[g],I=a.indexOf(v,d+1);if(u[g]){u[g]===v&&(delete u[g],Object.keys(u).forEach(function(R){w.parents[R]=!0}));continue}u[g]=v;var H=w.value;"string"!=typeof H?H=m(H):v.fmt&&(H=this.tmStrFormat(H,v,o)),a.splice.apply(a,[d+1,Math.max(0,I-d)].concat(H,v)),-1===w.indexOf(v)&&w.push(v)}}var D=0,V=0,K="";return a.forEach(function(R){if("string"==typeof R){var F=R.split("\n");F.length>1?(V=F[F.length-1].length,D+=F.length-1):V+=R.length,K+=R}else R&&(R.start?R.end={row:D,column:V}:R.start={row:D,column:V})}),{text:K,tabstops:f,tokens:a}},n=function(){function o(i){if(this.index=0,this.ranges=[],this.tabstops=[],i.tabstopManager)return i.tabstopManager;i.tabstopManager=this,this.$onChange=this.onChange.bind(this),this.$onChangeSelection=C.delayedCall(this.onChangeSelection.bind(this)).schedule,this.$onChangeSession=this.onChangeSession.bind(this),this.$onAfterExec=this.onAfterExec.bind(this),this.attach(i)}return o.prototype.attach=function(i){this.$openTabstops=null,this.selectedTabstop=null,this.editor=i,this.session=i.session,this.editor.on("change",this.$onChange),this.editor.on("changeSelection",this.$onChangeSelection),this.editor.on("changeSession",this.$onChangeSession),this.editor.commands.on("afterExec",this.$onAfterExec),this.editor.keyBinding.addKeyboardHandler(this.keyboardHandler)},o.prototype.detach=function(){this.tabstops.forEach(this.removeTabstopMarkers,this),this.ranges.length=0,this.tabstops.length=0,this.selectedTabstop=null,this.editor.off("change",this.$onChange),this.editor.off("changeSelection",this.$onChangeSelection),this.editor.off("changeSession",this.$onChangeSession),this.editor.commands.off("afterExec",this.$onAfterExec),this.editor.keyBinding.removeKeyboardHandler(this.keyboardHandler),this.editor.tabstopManager=null,this.session=null,this.editor=null},o.prototype.onChange=function(i){for(var e="r"==i.action[0],s=this.selectedTabstop||{},t=s.parents||{},r=this.tabstops.slice(),l=0;l<r.length;l++){var a=r[l];if(a.rangeList.$bias=a==s||t[a.index]?0:1,"remove"==i.action&&a!==s){var u=a.parents&&a.parents[s.index],m=a.rangeList.pointIndex(i.start,u);m=m<0?-m-1:m+1;for(var d=a.rangeList.pointIndex(i.end,u),v=a.rangeList.ranges.slice(m,d=d<0?-d-1:d-1),g=0;g<v.length;g++)this.removeRange(v[g])}a.rangeList.$onChange(i)}var w=this.session;!this.$inChange&&e&&1==w.getLength()&&!w.getValue()&&this.detach()},o.prototype.updateLinkedFields=function(){var i=this.selectedTabstop;if(i&&i.hasLinkedRanges&&i.firstNonLinked){this.$inChange=!0;for(var e=this.session,s=e.getTextRange(i.firstNonLinked),t=0;t<i.length;t++){var r=i[t];if(r.linked){var a=L.snippetManager.tmStrFormat(s,r.original,this.editor);e.replace(r,a)}}this.$inChange=!1}},o.prototype.onAfterExec=function(i){i.command&&!i.command.readOnly&&this.updateLinkedFields()},o.prototype.onChangeSelection=function(){if(this.editor){for(var i=this.editor.selection.lead,e=this.editor.selection.anchor,s=this.editor.selection.isEmpty(),t=0;t<this.ranges.length;t++)if(!this.ranges[t].linked){var r=this.ranges[t].contains(i.row,i.column),l=s||this.ranges[t].contains(e.row,e.column);if(r&&l)return}this.detach()}},o.prototype.onChangeSession=function(){this.detach()},o.prototype.tabNext=function(i){var e=this.tabstops.length,s=this.index+(i||1);(s=Math.min(Math.max(s,1),e))==e&&(s=0),this.selectTabstop(s),0===s&&this.detach()},o.prototype.selectTabstop=function(i){this.$openTabstops=null;var e=this.tabstops[this.index];if(e&&this.addTabstopMarkers(e),this.index=i,(e=this.tabstops[this.index])&&e.length){this.selectedTabstop=e;var s=e.firstNonLinked||e;if(e.choices&&(s.cursor=s.start),this.editor.inVirtualSelectionMode)this.editor.selection.fromOrientedRange(s);else{var t=this.editor.multiSelect;t.toSingleRange(s);for(var r=0;r<e.length;r++)e.hasLinkedRanges&&e[r].linked||t.addRange(e[r].clone(),!0)}this.editor.keyBinding.addKeyboardHandler(this.keyboardHandler),this.selectedTabstop&&this.selectedTabstop.choices&&this.editor.execCommand("startAutocomplete",{matches:this.selectedTabstop.choices})}},o.prototype.addTabstops=function(i,e,s){var t=this.useLink||!this.editor.getOption("enableMultiselect");if(this.$openTabstops||(this.$openTabstops=[]),!i[0]){var r=y.fromPoints(s,s);p(r.start,e),p(r.end,e),i[0]=[r],i[0].index=0}var a=[this.index+1,0],f=this.ranges;i.forEach(function(u,m){for(var d=this.$openTabstops[m]||u,v=0;v<u.length;v++){var g=u[v],w=y.fromPoints(g.start,g.end||g.start);c(w.start,e),c(w.end,e),w.original=g,w.tabstop=d,f.push(w),d!=u?d.unshift(w):d[v]=w,g.fmtString||d.firstNonLinked&&t?(w.linked=!0,d.hasLinkedRanges=!0):d.firstNonLinked||(d.firstNonLinked=w)}d.firstNonLinked||(d.hasLinkedRanges=!1),d===u&&(a.push(d),this.$openTabstops[m]=d),this.addTabstopMarkers(d),d.rangeList=d.rangeList||new x,d.rangeList.$bias=0,d.rangeList.addList(d)},this),a.length>2&&(this.tabstops.length&&a.push(a.splice(2,1)[0]),this.tabstops.splice.apply(this.tabstops,a))},o.prototype.addTabstopMarkers=function(i){var e=this.session;i.forEach(function(s){s.markerId||(s.markerId=e.addMarker(s,"ace_snippet-marker","text"))})},o.prototype.removeTabstopMarkers=function(i){var e=this.session;i.forEach(function(s){e.removeMarker(s.markerId),s.markerId=null})},o.prototype.removeRange=function(i){var e=i.tabstop.indexOf(i);-1!=e&&i.tabstop.splice(e,1),-1!=(e=this.ranges.indexOf(i))&&this.ranges.splice(e,1),-1!=(e=i.tabstop.rangeList.ranges.indexOf(i))&&i.tabstop.splice(e,1),this.session.removeMarker(i.markerId),i.tabstop.length||(-1!=(e=this.tabstops.indexOf(i.tabstop))&&this.tabstops.splice(e,1),this.tabstops.length||this.detach())},o}();n.prototype.keyboardHandler=new S,n.prototype.keyboardHandler.bindKeys({Tab:function(o){L.snippetManager&&L.snippetManager.expandWithTab(o)||(o.tabstopManager.tabNext(1),o.renderer.scrollCursorIntoView())},"Shift-Tab":function(o){o.tabstopManager.tabNext(-1),o.renderer.scrollCursorIntoView()},Esc:function(o){o.tabstopManager.detach()}});var c=function(o,i){0==o.row&&(o.column+=i.column),o.row+=i.row},p=function(o,i){o.row==i.row&&(o.column-=i.column),o.row-=i.row};_.importCssString("\n.ace_snippet-marker {\n    -moz-box-sizing: border-box;\n    box-sizing: border-box;\n    background: rgba(194, 193, 208, 0.09);\n    border: 1px dotted rgba(211, 208, 235, 0.62);\n    position: absolute;\n}","snippets.css",!1),L.snippetManager=new A;var h=b("./editor").Editor;(function(){this.insertSnippet=function(o,i){return L.snippetManager.insertSnippet(this,o,i)},this.expandSnippet=function(o){return L.snippetManager.expandWithTab(this,o)}}).call(h.prototype)}),ace.define("ace/autocomplete/popup",["require","exports","module","ace/virtual_renderer","ace/editor","ace/range","ace/lib/event","ace/lib/lang","ace/lib/dom","ace/config"],function(b,L,U){"use strict";var _=b("../virtual_renderer").VirtualRenderer,M=b("../editor").Editor,E=b("../range").Range,C=b("../lib/event"),y=b("../lib/lang"),x=b("../lib/dom"),S=b("../config").nls,O=function(T){return"suggest-aria-id:".concat(T)},k=function(T){var A=new _(T);A.$maxLines=4;var $=new M(A);return $.setHighlightActiveLine(!1),$.setShowPrintMargin(!1),$.renderer.setShowGutter(!1),$.renderer.setHighlightGutterLine(!1),$.$mouseHandler.$focusTimeout=0,$.$highlightTagPending=!0,$};x.importCssString("\n.ace_editor.ace_autocomplete .ace_marker-layer .ace_active-line {\n    background-color: #CAD6FA;\n    z-index: 1;\n}\n.ace_dark.ace_editor.ace_autocomplete .ace_marker-layer .ace_active-line {\n    background-color: #3a674e;\n}\n.ace_editor.ace_autocomplete .ace_line-hover {\n    border: 1px solid #abbffe;\n    margin-top: -1px;\n    background: rgba(233,233,253,0.4);\n    position: absolute;\n    z-index: 2;\n}\n.ace_dark.ace_editor.ace_autocomplete .ace_line-hover {\n    border: 1px solid rgba(109, 150, 13, 0.8);\n    background: rgba(58, 103, 78, 0.62);\n}\n.ace_completion-meta {\n    opacity: 0.5;\n    margin-left: 0.9em;\n}\n.ace_completion-message {\n    color: blue;\n}\n.ace_editor.ace_autocomplete .ace_completion-highlight{\n    color: #2d69c7;\n}\n.ace_dark.ace_editor.ace_autocomplete .ace_completion-highlight{\n    color: #93ca12;\n}\n.ace_editor.ace_autocomplete {\n    width: 300px;\n    z-index: 200000;\n    border: 1px lightgray solid;\n    position: fixed;\n    box-shadow: 2px 3px 5px rgba(0,0,0,.2);\n    line-height: 1.4;\n    background: #fefefe;\n    color: #111;\n}\n.ace_dark.ace_editor.ace_autocomplete {\n    border: 1px #484747 solid;\n    box-shadow: 2px 3px 5px rgba(0, 0, 0, 0.51);\n    line-height: 1.4;\n    background: #25282c;\n    color: #c1c1c1;\n}\n.ace_autocomplete .ace_text-layer  {\n    width: calc(100% - 8px);\n}\n.ace_autocomplete .ace_line {\n    display: flex;\n    align-items: center;\n}\n.ace_autocomplete .ace_line > * {\n    min-width: 0;\n    flex: 0 0 auto;\n}\n.ace_autocomplete .ace_line .ace_ {\n    flex: 0 1 auto;\n    overflow: hidden;\n    white-space: nowrap;\n    text-overflow: ellipsis;\n}\n.ace_autocomplete .ace_completion-spacer {\n    flex: 1;\n}\n","autocompletion.css",!1),L.AcePopup=function T(A){var $=x.createElement("div"),n=new k($);A&&A.appendChild($),$.style.display="none",n.renderer.content.style.cursor="default",n.renderer.setStyle("ace_autocomplete"),n.renderer.$textLayer.element.setAttribute("role","listbox"),n.renderer.$textLayer.element.setAttribute("aria-label",S("Autocomplete suggestions")),n.renderer.textarea.setAttribute("aria-hidden","true"),n.setOption("displayIndentGuides",!1),n.setOption("dragDelay",150);var c=function(){};n.focus=c,n.$isFocused=!0,n.renderer.$cursorLayer.restartTimer=c,n.renderer.$cursorLayer.element.style.opacity=0,n.renderer.$maxLines=8,n.renderer.$keepTextAreaAtCursor=!1,n.setHighlightActiveLine(!1),n.session.highlight(""),n.session.$searchHighlight.clazz="ace_highlight-marker",n.on("mousedown",function(t){var r=t.getDocumentPosition();n.selection.moveToPosition(r),o.start.row=o.end.row=r.row,t.stop()});var p,h=new E(-1,0,-1,1/0),o=new E(-1,0,-1,1/0);o.id=n.session.addMarker(o,"ace_active-line","fullLine"),n.setSelectOnHover=function(t){t?h.id&&(n.session.removeMarker(h.id),h.id=null):h.id=n.session.addMarker(h,"ace_line-hover","fullLine")},n.setSelectOnHover(!1),n.on("mousemove",function(t){if(p){if(p.x!=t.x||p.y!=t.y){(p=t).scrollTop=n.renderer.scrollTop;var r=p.getDocumentPosition().row;h.start.row!=r&&(h.id||n.setRow(r),e(r))}}else p=t}),n.renderer.on("beforeRender",function(){if(p&&-1!=h.start.row){p.$pos=null;var t=p.getDocumentPosition().row;h.id||n.setRow(t),e(t,!0)}}),n.renderer.on("afterRender",function(){var t=n.getRow(),r=n.renderer.$textLayer,l=r.element.childNodes[t-r.config.firstRow],a=document.activeElement;if(l!==r.selectedNode&&r.selectedNode&&(x.removeCssClass(r.selectedNode,"ace_selected"),a.removeAttribute("aria-activedescendant"),r.selectedNode.removeAttribute("id")),r.selectedNode=l,l){x.addCssClass(l,"ace_selected");var f=O(t);l.id=f,r.element.setAttribute("aria-activedescendant",f),a.setAttribute("aria-activedescendant",f),l.setAttribute("role","option"),l.setAttribute("aria-label",n.getData(t).value),l.setAttribute("aria-setsize",n.data.length),l.setAttribute("aria-posinset",t+1),l.setAttribute("aria-describedby","doc-tooltip")}});var i=function(){e(-1)},e=function(t,r){t!==h.start.row&&(h.start.row=h.end.row=t,r||n.session._emit("changeBackMarker"),n._emit("changeHoverMarker"))};n.getHoveredRow=function(){return h.start.row},C.addListener(n.container,"mouseout",i),n.on("hide",i),n.on("changeSelection",i),n.session.doc.getLength=function(){return n.data.length},n.session.doc.getLine=function(t){var r=n.data[t];return"string"==typeof r?r:r&&r.value||""};var s=n.session.bgTokenizer;return s.$tokenizeRow=function(t){var r=n.data[t],l=[];if(!r)return l;"string"==typeof r&&(r={value:r});var a=r.caption||r.value||r.name;function f(H,D){H&&l.push({type:(r.className||"")+(D||""),value:H})}for(var u=a.toLowerCase(),m=(n.filterText||"").toLowerCase(),d=0,v=0,g=0;g<=m.length;g++)if(g!=v&&(r.matchMask&1<<g||g==m.length)){var w=m.slice(v,g);v=g;var I=u.indexOf(w,d);if(-1==I)continue;f(a.slice(d,I),""),f(a.slice(I,d=I+w.length),"completion-highlight")}return f(a.slice(d,a.length),""),l.push({type:"completion-spacer",value:" "}),r.meta&&l.push({type:"completion-meta",value:r.meta}),r.message&&l.push({type:"completion-message",value:r.message}),l},s.$updateOnChange=c,s.start=c,n.session.$computeWidth=function(){return this.screenWidth=0},n.isOpen=!1,n.isTopdown=!1,n.autoSelect=!0,n.filterText="",n.data=[],n.setData=function(t,r){n.filterText=r||"",n.setValue(y.stringRepeat("\n",t.length),-1),n.data=t||[],n.setRow(0)},n.getData=function(t){return n.data[t]},n.getRow=function(){return o.start.row},n.setRow=function(t){t=Math.max(this.autoSelect?0:-1,Math.min(this.data.length-1,t)),o.start.row!=t&&(n.selection.clearSelection(),o.start.row=o.end.row=t||0,n.session._emit("changeBackMarker"),n.moveCursorTo(t||0,0),n.isOpen&&n._signal("select"))},n.on("changeSelection",function(){n.isOpen&&n.setRow(n.selection.lead.row),n.renderer.scrollCursorIntoView()}),n.hide=function(){this.container.style.display="none",n.anchorPos=null,n.anchor=null,n.isOpen&&(n.isOpen=!1,this._signal("hide"))},n.tryShow=function(t,r,l,a){if(!a&&n.isOpen&&n.anchorPos&&n.anchor&&n.anchorPos.top===t.top&&n.anchorPos.left===t.left&&n.anchor===l)return!0;var f=this.container,u=window.innerHeight,m=window.innerWidth,d=this.renderer,v=d.$maxLines*r*1.4,g={top:0,bottom:0,left:0},w=u-t.top-3*this.$borderSize-r,I=t.top-3*this.$borderSize;l||(l=I<=w||w>=v?"bottom":"top"),"top"===l?(g.bottom=t.top-this.$borderSize,g.top=g.bottom-v):"bottom"===l&&(g.top=t.top+r+this.$borderSize,g.bottom=g.top+v);var H=g.top>=0&&g.bottom<=u;if(!a&&!H)return!1;d.$maxPixelHeight=H?null:"top"===l?I:w,"top"===l?(f.style.top="",f.style.bottom=u-g.bottom+"px",n.isTopdown=!1):(f.style.top=g.top+"px",f.style.bottom="",n.isTopdown=!0),f.style.display="";var D=t.left;return D+f.offsetWidth>m&&(D=m-f.offsetWidth),f.style.left=D+"px",f.style.right="",n.isOpen||(n.isOpen=!0,this._signal("show"),p=null),n.anchorPos=t,n.anchor=l,!0},n.show=function(t,r,l){this.tryShow(t,r,l?"bottom":void 0,!0)},n.goTo=function(t){var r=this.getRow(),l=this.session.getLength()-1;switch(t){case"up":r=r<=0?l:r-1;break;case"down":r=r>=l?-1:r+1;break;case"start":r=0;break;case"end":r=l}this.setRow(r)},n.getTextLeftOffset=function(){return this.$borderSize+this.renderer.$padding+this.$imageSize},n.$imageSize=0,n.$borderSize=1,n},L.$singleLineEditor=k,L.getAriaId=O}),ace.define("ace/autocomplete/inline",["require","exports","module","ace/snippets"],function(b,L,U){"use strict";var _=b("../snippets").snippetManager,M=function(){function E(){this.editor=null}return E.prototype.show=function(C,y,x){if(x=x||"",C&&this.editor&&this.editor!==C&&(this.hide(),this.editor=null),!C||!y)return!1;var S=y.snippet?_.getDisplayTextForSnippet(C,y.snippet):y.value;return!(!S||!S.startsWith(x)||(this.editor=C,""===(S=S.slice(x.length))?C.removeGhostText():C.setGhostText(S),0))},E.prototype.isOpen=function(){return!!this.editor&&!!this.editor.renderer.$ghostText},E.prototype.hide=function(){return!!this.editor&&(this.editor.removeGhostText(),!0)},E.prototype.destroy=function(){this.hide(),this.editor=null},E}();L.AceInline=M}),ace.define("ace/autocomplete/util",["require","exports","module"],function(b,L,U){"use strict";L.parForEach=function(M,E,C){var y=0,x=M.length;0===x&&C();for(var S=0;S<x;S++)E(M[S],function(O,k){++y===x&&C(O,k)})};var _=/[a-zA-Z_0-9\$\-\u00A2-\u2000\u2070-\uFFFF]/;L.retrievePrecedingIdentifier=function(M,E,C){C=C||_;for(var y=[],x=E-1;x>=0&&C.test(M[x]);x--)y.push(M[x]);return y.reverse().join("")},L.retrieveFollowingIdentifier=function(M,E,C){C=C||_;for(var y=[],x=E;x<M.length&&C.test(M[x]);x++)y.push(M[x]);return y},L.getCompletionPrefix=function(M){var y,E=M.getCursorPosition(),C=M.session.getLine(E.row);return M.completers.forEach(function(x){x.identifierRegexps&&x.identifierRegexps.forEach(function(S){!y&&S&&(y=this.retrievePrecedingIdentifier(C,E.column,S))}.bind(this))}.bind(this)),y||this.retrievePrecedingIdentifier(C,E.column)},L.triggerAutocomplete=function(M){var E=M.getCursorPosition(),x=M.session.getLine(E.row)[0===E.column?0:E.column-1];return M.completers.some(function(S){if(S.triggerCharacters&&Array.isArray(S.triggerCharacters))return S.triggerCharacters.includes(x)})}}),ace.define("ace/autocomplete",["require","exports","module","ace/keyboard/hash_handler","ace/autocomplete/popup","ace/autocomplete/inline","ace/autocomplete/popup","ace/autocomplete/util","ace/lib/lang","ace/lib/dom","ace/snippets","ace/config"],function(b,L,U){"use strict";var _=b("./keyboard/hash_handler").HashHandler,M=b("./autocomplete/popup").AcePopup,E=b("./autocomplete/inline").AceInline,C=b("./autocomplete/popup").getAriaId,y=b("./autocomplete/util"),x=b("./lib/lang"),S=b("./lib/dom"),O=b("./snippets").snippetManager,k=b("./config"),P=function(n,c){c.completer&&c.completer.destroy()},T=function(){function n(){this.autoInsert=!1,this.autoSelect=!0,this.autoShown=!1,this.exactMatch=!1,this.inlineEnabled=!1,this.keyboardHandler=new _,this.keyboardHandler.bindKeys(this.commands),this.parentNode=null,this.blurListener=this.blurListener.bind(this),this.changeListener=this.changeListener.bind(this),this.mousedownListener=this.mousedownListener.bind(this),this.mousewheelListener=this.mousewheelListener.bind(this),this.onLayoutChange=this.onLayoutChange.bind(this),this.changeTimer=x.delayedCall(function(){this.updateCompletions(!0)}.bind(this)),this.tooltipTimer=x.delayedCall(this.updateDocTooltip.bind(this),50)}return n.prototype.$init=function(){return this.popup=new M(this.parentNode||document.body||document.documentElement),this.popup.on("click",function(c){this.insertMatch(),c.stop()}.bind(this)),this.popup.focus=this.editor.focus.bind(this.editor),this.popup.on("show",this.$onPopupChange.bind(this)),this.popup.on("hide",this.$onHidePopup.bind(this)),this.popup.on("select",this.$onPopupChange.bind(this)),this.popup.on("changeHoverMarker",this.tooltipTimer.bind(null,null)),this.popup},n.prototype.$initInline=function(){if(this.inlineEnabled&&!this.inlineRenderer)return this.inlineRenderer=new E,this.inlineRenderer},n.prototype.getPopup=function(){return this.popup||this.$init()},n.prototype.$onHidePopup=function(){this.inlineRenderer&&this.inlineRenderer.hide(),this.hideDocTooltip()},n.prototype.$onPopupChange=function(c){if(this.inlineRenderer&&this.inlineEnabled){var p=c?null:this.popup.getData(this.popup.getRow()),h=y.getCompletionPrefix(this.editor);this.inlineRenderer.show(this.editor,p,h)||this.inlineRenderer.hide(),this.$updatePopupPosition()}this.tooltipTimer.call(null,null)},n.prototype.observeLayoutChanges=function(){if(!this.$elements&&this.editor){window.addEventListener("resize",this.onLayoutChange,{passive:!0}),window.addEventListener("wheel",this.mousewheelListener);for(var c=this.editor.container.parentNode,p=[];c;)p.push(c),c.addEventListener("scroll",this.onLayoutChange,{passive:!0}),c=c.parentNode;this.$elements=p}},n.prototype.unObserveLayoutChanges=function(){var c=this;window.removeEventListener("resize",this.onLayoutChange,{passive:!0}),window.removeEventListener("wheel",this.mousewheelListener),this.$elements&&this.$elements.forEach(function(p){p.removeEventListener("scroll",c.onLayoutChange,{passive:!0})}),this.$elements=null},n.prototype.onLayoutChange=function(){if(!this.popup.isOpen)return this.unObserveLayoutChanges();this.$updatePopupPosition(),this.updateDocTooltip()},n.prototype.$updatePopupPosition=function(){var c=this.editor,p=c.renderer,h=p.layerConfig.lineHeight,o=p.$cursorLayer.getPixelPosition(this.base,!0);o.left-=this.popup.getTextLeftOffset();var i=c.container.getBoundingClientRect();o.top+=i.top-p.layerConfig.offset,o.left+=i.left-c.renderer.scrollLeft,o.left+=p.gutterWidth;var e={top:o.top,left:o.left};p.$ghostText&&p.$ghostTextWidget&&this.base.row===p.$ghostText.position.row&&(e.top+=p.$ghostTextWidget.el.offsetHeight),!this.popup.tryShow(e,h,"bottom")&&(this.popup.tryShow(o,h,"top")||this.popup.show(o,h))},n.prototype.openPopup=function(c,p,h){this.popup||this.$init(),this.inlineEnabled&&!this.inlineRenderer&&this.$initInline(),this.popup.autoSelect=this.autoSelect,this.popup.setData(this.completions.filtered,this.completions.filterText),this.editor.textInput.setAriaOptions&&this.editor.textInput.setAriaOptions({activeDescendant:C(this.popup.getRow()),inline:this.inlineEnabled}),c.keyBinding.addKeyboardHandler(this.keyboardHandler),this.popup.setRow(this.autoSelect?0:-1),h?h&&!p&&this.detach():(this.popup.setTheme(c.getTheme()),this.popup.setFontSize(c.getFontSize()),this.$updatePopupPosition(),this.tooltipNode&&this.updateDocTooltip()),this.changeTimer.cancel(),this.observeLayoutChanges()},n.prototype.detach=function(){this.editor&&(this.editor.keyBinding.removeKeyboardHandler(this.keyboardHandler),this.editor.off("changeSelection",this.changeListener),this.editor.off("blur",this.blurListener),this.editor.off("mousedown",this.mousedownListener),this.editor.off("mousewheel",this.mousewheelListener)),this.changeTimer.cancel(),this.hideDocTooltip(),this.completionProvider&&this.completionProvider.detach(),this.popup&&this.popup.isOpen&&this.popup.hide(),this.base&&this.base.detach(),this.activated=!1,this.completionProvider=this.completions=this.base=null,this.unObserveLayoutChanges()},n.prototype.changeListener=function(c){var p=this.editor.selection.lead;(p.row!=this.base.row||p.column<this.base.column)&&this.detach(),this.activated?this.changeTimer.schedule():this.detach()},n.prototype.blurListener=function(c){var p=document.activeElement,h=this.editor.textInput.getElement(),o=c.relatedTarget&&this.tooltipNode&&this.tooltipNode.contains(c.relatedTarget);p!=h&&p.parentNode!=(this.popup&&this.popup.container)&&!o&&p!=this.tooltipNode&&c.relatedTarget!=h&&this.detach()},n.prototype.mousedownListener=function(c){this.detach()},n.prototype.mousewheelListener=function(c){this.detach()},n.prototype.goTo=function(c){this.popup.goTo(c)},n.prototype.insertMatch=function(c,p){if(c||(c=this.popup.getData(this.popup.getRow())),!c)return!1;if(""===c.value)return this.detach();var h=this.completions,o=this.getCompletionProvider().insertMatch(this.editor,c,h.filterText,p);return this.completions==h&&this.detach(),o},n.prototype.showPopup=function(c,p){this.editor&&this.detach(),this.activated=!0,this.editor=c,c.completer!=this&&(c.completer&&c.completer.detach(),c.completer=this),c.on("changeSelection",this.changeListener),c.on("blur",this.blurListener),c.on("mousedown",this.mousedownListener),c.on("mousewheel",this.mousewheelListener),this.updateCompletions(!1,p)},n.prototype.getCompletionProvider=function(){return this.completionProvider||(this.completionProvider=new A),this.completionProvider},n.prototype.gatherCompletions=function(c,p){return this.getCompletionProvider().gatherCompletions(c,p)},n.prototype.updateCompletions=function(c,p){if(c&&this.base&&this.completions){var o=this.editor.getCursorPosition();if((i=this.editor.session.getTextRange({start:this.base,end:o}))==this.completions.filterText)return;return this.completions.setFilter(i),this.completions.filtered.length&&(1!=this.completions.filtered.length||this.completions.filtered[0].value!=i||this.completions.filtered[0].snippet)?void this.openPopup(this.editor,i,c):this.detach()}if(p&&p.matches)return o=this.editor.getSelectionRange().start,this.base=this.editor.session.doc.createAnchor(o.row,o.column),this.base.$insertRight=!0,this.completions=new $(p.matches),this.openPopup(this.editor,"",c);var h=this.editor.getSession(),i=(o=this.editor.getCursorPosition(),y.getCompletionPrefix(this.editor));this.base=h.doc.createAnchor(o.row,o.column-i.length),this.base.$insertRight=!0;var e={exactMatch:this.exactMatch};this.getCompletionProvider().provideCompletions(this.editor,e,function(s,t,r){var l=t.filtered,a=y.getCompletionPrefix(this.editor);if(r){if(!l.length){var f=!this.autoShown&&this.emptyMessage;if("function"==typeof f&&(f=this.emptyMessage(a)),f){var u=[{caption:this.emptyMessage(a),value:""}];return this.completions=new $(u),void this.openPopup(this.editor,a,c)}return this.detach()}if(1==l.length&&l[0].value==a&&!l[0].snippet)return this.detach();if(this.autoInsert&&!this.autoShown&&1==l.length)return this.insertMatch(l[0])}this.completions=t,this.openPopup(this.editor,a,c)}.bind(this))},n.prototype.cancelContextMenu=function(){this.editor.$mouseHandler.cancelContextMenu()},n.prototype.updateDocTooltip=function(){var c=this.popup,p=c.data,h=p&&(p[c.getHoveredRow()]||p[c.getRow()]),o=null;if(!h||!this.editor||!this.popup.isOpen)return this.hideDocTooltip();for(var i=this.editor.completers.length,e=0;e<i;e++){var s=this.editor.completers[e];if(s.getDocTooltip&&h.completerId===s.id){o=s.getDocTooltip(h);break}}if(!o&&"string"!=typeof h&&(o=h),"string"==typeof o&&(o={docText:o}),!o||!o.docHTML&&!o.docText)return this.hideDocTooltip();this.showDocTooltip(o)},n.prototype.showDocTooltip=function(c){this.tooltipNode||(this.tooltipNode=S.createElement("div"),this.tooltipNode.style.margin=0,this.tooltipNode.style.pointerEvents="auto",this.tooltipNode.tabIndex=-1,this.tooltipNode.onblur=this.blurListener.bind(this),this.tooltipNode.onclick=this.onTooltipClick.bind(this),this.tooltipNode.id="doc-tooltip",this.tooltipNode.setAttribute("role","tooltip"));var p=this.editor.renderer.theme;this.tooltipNode.className="ace_tooltip ace_doc-tooltip "+(p.isDark?"ace_dark ":"")+(p.cssClass||"");var h=this.tooltipNode;c.docHTML?h.innerHTML=c.docHTML:c.docText&&(h.textContent=c.docText),h.parentNode||this.popup.container.appendChild(this.tooltipNode);var o=this.popup,i=o.container.getBoundingClientRect();h.style.top=o.container.style.top,h.style.bottom=o.container.style.bottom,h.style.display="block",window.innerWidth-i.right<320?i.left<320?o.isTopdown?(h.style.top=i.bottom+"px",h.style.left=i.left+"px",h.style.right="",h.style.bottom=""):(h.style.top=o.container.offsetTop-h.offsetHeight+"px",h.style.left=i.left+"px",h.style.right="",h.style.bottom=""):(h.style.right=window.innerWidth-i.left+"px",h.style.left=""):(h.style.left=i.right+1+"px",h.style.right="")},n.prototype.hideDocTooltip=function(){if(this.tooltipTimer.cancel(),this.tooltipNode){var c=this.tooltipNode;!this.editor.isFocused()&&document.activeElement==c&&this.editor.focus(),this.tooltipNode=null,c.parentNode&&c.parentNode.removeChild(c)}},n.prototype.onTooltipClick=function(c){for(var p=c.target;p&&p!=this.tooltipNode;){if("A"==p.nodeName&&p.href){p.rel="noreferrer",p.target="_blank";break}p=p.parentNode}},n.prototype.destroy=function(){if(this.detach(),this.popup){this.popup.destroy();var c=this.popup.container;c&&c.parentNode&&c.parentNode.removeChild(c)}this.editor&&this.editor.completer==this&&(this.editor.off("destroy",P),this.editor.completer=null),this.inlineRenderer=this.popup=this.editor=null},n}();T.prototype.commands={Up:function(n){n.completer.goTo("up")},Down:function(n){n.completer.goTo("down")},"Ctrl-Up|Ctrl-Home":function(n){n.completer.goTo("start")},"Ctrl-Down|Ctrl-End":function(n){n.completer.goTo("end")},Esc:function(n){n.completer.detach()},Return:function(n){return n.completer.insertMatch()},"Shift-Return":function(n){n.completer.insertMatch(null,{deleteSuffix:!0})},Tab:function(n){var c=n.completer.insertMatch();if(c||n.tabstopManager)return c;n.completer.goTo("down")},PageUp:function(n){n.completer.popup.gotoPageUp()},PageDown:function(n){n.completer.popup.gotoPageDown()}},T.for=function(n){return n.completer instanceof T||(n.completer&&(n.completer.destroy(),n.completer=null),k.get("sharedPopups")?(T.$sharedInstance||(T.$sharedInstance=new T),n.completer=T.$sharedInstance):(n.completer=new T,n.once("destroy",P))),n.completer},T.startCommand={name:"startAutocomplete",exec:function(n,c){var p=T.for(n);p.autoInsert=!1,p.autoSelect=!0,p.autoShown=!1,p.showPopup(n,c),p.cancelContextMenu()},bindKey:"Ctrl-Space|Ctrl-Shift-Space|Alt-Space"};var A=function(){function n(){this.active=!0}return n.prototype.insertByIndex=function(c,p,h){return!(!this.completions||!this.completions.filtered)&&this.insertMatch(c,this.completions.filtered[p],h)},n.prototype.insertMatch=function(c,p,h){if(!p)return!1;if(c.startOperation({command:{name:"insertMatch"}}),p.completer&&p.completer.insertMatch)p.completer.insertMatch(c,p);else{if(!this.completions)return!1;if(this.completions.filterText&&!p.range){var o;o=c.selection.getAllRanges?c.selection.getAllRanges():[c.getSelectionRange()];for(var e,i=0;e=o[i];i++)e.start.column-=this.completions.filterText.length,c.session.remove(e)}p.snippet?O.insertSnippet(c,p.snippet,{range:p.range}):this.$insertString(c,p),p.command&&"startAutocomplete"===p.command&&c.execCommand(p.command)}return c.endOperation(),!0},n.prototype.$insertString=function(c,p){var h=p.value||p;if(p.range){if(c.inVirtualSelectionMode)return c.session.replace(p.range,h);c.forEachSelection(function(){var o=c.getSelectionRange();0===p.range.compareRange(o)?c.session.replace(p.range,h):c.insert(h)},null,{keepOrder:!0})}else c.execCommand("insertstring",h)},n.prototype.gatherCompletions=function(c,p){var h=c.getSession(),o=c.getCursorPosition(),i=y.getCompletionPrefix(c),e=[];this.completers=c.completers;var s=c.completers.length;return c.completers.forEach(function(t,r){t.getCompletions(c,h,o,i,function(l,a){!l&&a&&(e=e.concat(a)),p(null,{prefix:y.getCompletionPrefix(c),matches:e,finished:0==--s})})}),!0},n.prototype.provideCompletions=function(c,p,h){var o=function(t){var r=t.prefix;this.completions=new $(t.matches),p.exactMatch&&(this.completions.exactMatch=!0),p.ignoreCaption&&(this.completions.ignoreCaption=!0),this.completions.setFilter(r),(t.finished||this.completions.filtered.length)&&h(null,this.completions,t.finished)}.bind(this),i=!0,e=null;if(this.gatherCompletions(c,function(t,r){if(this.active&&(t&&(h(t,[],!0),this.detach()),0===r.prefix.indexOf(r.prefix))){if(i)return void(e=r);o(r)}}.bind(this)),i=!1,e){var s=e;e=null,o(s)}},n.prototype.detach=function(){this.active=!1,this.completers&&this.completers.forEach(function(c){"function"==typeof c.cancel&&c.cancel()})},n}(),$=function(){function n(c,p){this.all=c,this.filtered=c,this.filterText=p||"",this.exactMatch=!1,this.ignoreCaption=!1}return n.prototype.setFilter=function(c){if(c.length>this.filterText&&0===c.lastIndexOf(this.filterText,0))var p=this.filtered;else p=this.all;this.filterText=c,p=(p=this.filterCompletions(p,this.filterText)).sort(function(o,i){return i.exactMatch-o.exactMatch||i.$score-o.$score||(o.caption||o.value).localeCompare(i.caption||i.value)});var h=null;p=p.filter(function(o){var i=o.snippet||o.caption||o.value;return i!==h&&(h=i,!0)}),this.filtered=p},n.prototype.filterCompletions=function(c,p){var h=[],o=p.toUpperCase(),i=p.toLowerCase();e:for(var s,e=0;s=c[e];e++){var t=!this.ignoreCaption&&s.caption||s.value||s.snippet;if(t){var f,u,r=-1,l=0,a=0;if(this.exactMatch){if(p!==t.substr(0,p.length))continue e}else{var m=t.toLowerCase().indexOf(i);if(m>-1)a=m;else for(var d=0;d<p.length;d++){var v=t.indexOf(i[d],r+1),g=t.indexOf(o[d],r+1);if((f=v>=0&&(g<0||v<g)?v:g)<0)continue e;(u=f-r-1)>0&&(-1===r&&(a+=10),a+=u,l|=1<<d),r=f}}s.matchMask=l,s.exactMatch=a?0:1,s.$score=(s.score||0)-a,h.push(s)}}return h},n}();L.Autocomplete=T,L.CompletionProvider=A,L.FilteredList=$}),ace.define("ace/autocomplete/text_completer",["require","exports","module","ace/range"],function(b,L,U){var _=b("../range").Range,M=/[^a-zA-Z_0-9\$\-\u00C0-\u1FFF\u2C00-\uD7FF\w]+/;L.getCompletions=function(y,x,S,O,k){var P=function C(y,x){var S=function E(y,x){return y.getTextRange(_.fromPoints({row:0,column:0},x)).split(M).length-1}(y,x),O=y.getValue().split(M),k=Object.create(null),P=O[S];return O.forEach(function(T,A){if(T&&T!==P){var $=Math.abs(S-A),n=O.length-$;k[T]=k[T]?Math.max(n,k[T]):n}}),k}(x,S);k(null,Object.keys(P).map(function(A){return{caption:A,value:A,score:P[A],meta:"local"}}))}}),ace.define("ace/ext/language_tools",["require","exports","module","ace/snippets","ace/autocomplete","ace/config","ace/lib/lang","ace/autocomplete/util","ace/autocomplete/text_completer","ace/editor","ace/config"],function(b,L,U){"use strict";var _=b("../snippets").snippetManager,M=b("../autocomplete").Autocomplete,E=b("../config"),C=b("../lib/lang"),y=b("../autocomplete/util"),x=b("../autocomplete/text_completer"),S={getCompletions:function(e,s,t,r,l){if(s.$mode.completer)return s.$mode.completer.getCompletions(e,s,t,r,l);var a=e.session.getState(t.row),f=s.$mode.getCompletions(a,s,t,r);l(null,f=f.map(function(u){return u.completerId=S.id,u}))},id:"keywordCompleter"},O=function(e){var s={};return e.replace(/\${(\d+)(:(.*?))?}/g,function(t,r,l,a){return s[r]=a||""}).replace(/\$(\d+?)/g,function(t,r){return s[r]})},k={getCompletions:function(e,s,t,r,l){var a=[],f=s.getTokenAt(t.row,t.column);f&&f.type.match(/(tag-name|tag-open|tag-whitespace|attribute-name|attribute-value)\.xml$/)?a.push("html-tag"):a=_.getActiveScopes(e);var u=_.snippetMap,m=[];a.forEach(function(d){for(var v=u[d]||[],g=v.length;g--;){var w=v[g],I=w.name||w.tabTrigger;!I||m.push({caption:I,snippet:w.content,meta:w.tabTrigger&&!w.name?w.tabTrigger+"\u21e5 ":"snippet",completerId:k.id})}},this),l(null,m)},getDocTooltip:function(e){e.snippet&&!e.docHTML&&(e.docHTML=["<b>",C.escapeHTML(e.caption),"</b>","<hr></hr>",C.escapeHTML(O(e.snippet))].join(""))},id:"snippetCompleter"},P=[k,x,S];L.setCompleters=function(e){P.length=0,e&&P.push.apply(P,e)},L.addCompleter=function(e){P.push(e)},L.textCompleter=x,L.keyWordCompleter=S,L.snippetCompleter=k;var p,T={name:"expandSnippet",exec:function(e){return _.expandWithTab(e)},bindKey:"Tab"},A=function(e,s){$(s.session.$mode)},$=function(e){"string"==typeof e&&(e=E.$modes[e]),e&&(_.files||(_.files={}),n(e.$id,e.snippetFileId),e.modes&&e.modes.forEach($))},n=function(e,s){!s||!e||_.files[e]||(_.files[e]={},E.loadModule(s,function(t){!t||(_.files[e]=t,!t.snippets&&t.snippetText&&(t.snippets=_.parseSnippetFile(t.snippetText)),_.register(t.snippets||[],t.scope),t.includeScopes&&(_.snippetMap[t.scope].includeScopes=t.includeScopes,t.includeScopes.forEach(function(r){$("ace/mode/"+r)})))}))},c=function(e){var s=e.editor,t=s.completer&&s.completer.activated;if("backspace"===e.command.name)t&&!y.getCompletionPrefix(s)&&s.completer.detach();else if("insertstring"===e.command.name&&!t){p=e;var r=e.editor.$liveAutocompletionDelay;r?h.delay(r):o(e)}},h=C.delayedCall(function(){o(p)},0),o=function(e){var s=e.editor,t=y.getCompletionPrefix(s),r=y.triggerAutocomplete(s);if((t||r)&&t.length>=s.$liveAutocompletionThreshold){var l=M.for(s);l.autoShown=!0,l.showPopup(s)}},i=b("../editor").Editor;b("../config").defineOptions(i.prototype,"editor",{enableBasicAutocompletion:{set:function(e){e?(this.completers||(this.completers=Array.isArray(e)?e:P),this.commands.addCommand(M.startCommand)):this.commands.removeCommand(M.startCommand)},value:!1},enableLiveAutocompletion:{set:function(e){e?(this.completers||(this.completers=Array.isArray(e)?e:P),this.commands.on("afterExec",c)):this.commands.off("afterExec",c)},value:!1},liveAutocompletionDelay:{initialValue:0},liveAutocompletionThreshold:{initialValue:0},enableSnippets:{set:function(e){e?(this.commands.addCommand(T),this.on("changeMode",A),A(0,this)):(this.commands.removeCommand(T),this.off("changeMode",A))},value:!1}})}),ace.require(["ace/ext/language_tools"],function(b){"object"==typeof module&&"object"==typeof exports&&module&&(module.exports=b)});